* Current version
2.2.2.2.2   Sat Sep 29 16:22:20 PDT 2012
BeStMan and SRM-Clients Copyright(c) 2007-2012,
Lawrence Berkeley National Laboratory. All rights reserved.
Support at SRM@LBL.GOV and documents at http://sdm.lbl.gov/bestman

Open Science Grid (OSG) support:  osg-storage@opensciencegrid.org
All Tier 3 sites and users
    for ATLAS, Doug Benjamin <benjamin@phy.duke.edu>
    for CMS, Rob Snihur <snihur@fnal.gov>

2.2.2.2.2   Sat Sep 29 16:22:20 PDT 2012
* server
1. BeStMan Gateway now supports Transfer Protocol selection (requested by EOS)
2. bug fix in the MSS plugin interface for srmLs

2.2.2.2.1   Wed May  9 09:30:39 PDT 2012
* setup
1. setup configurations and scripts are separated from the source release
2. setup is maintained separately
3. setup-osg is maintained by OSG team separeately


2.2.2.2.0  Fri Jan 13 08:05:56 PST 2012
* bestman server/client/tester
1. all libs updates to the latest
2. $distribution/etc/bestman2 contains all external environment variables
3. $distribution/conf/bestman2.rc contains all internal configuration entries for serverr
4. all sources are up to date
5. Oracle/SUN Java 1.6.0_27 or later support
   Oracle/SUN Java 1.7.0 support
   OpenJDK 1.7.0 support
6. GUMS XACML service support
   No support on GUMS SAML service (use bestman2-2.1.3 release)
7. No support on SHA-2 based GSI
   Java CoG JGlobus 1.8 does not support SHA-2 based GSI
   Java CoG JGlobus 2.0 does not support HTTPG
8. added/checked gsiftp/file protocol support in srm-rm/srm-mkdir/srm-rmdir
9. updated status logging in server

2.2.2.1.3  Mon Sep 26 14:08:48 PDT 2011
* bestman server
1. OpenJDK/JDK 1.7 compatible
   Running on both OpenJDK/JDK 1.7 and JDK 1.6.0_27 (tested)
2. added more control and debug in MSS queue (full mode)

* setup
1. updated on Java version check


2.2.2.1.2   Tue Aug 23 11:20:37 PDT 2011
* bestman server
1. added sudo functionality on ls with a configurable option in bestman2.rc
   noSudoOnLs=false

2.2.2.1.1   Thu Jul 28 13:13:31 PDT 2011
* bestman server
1. added configuration entry support (sudoCommand).
   e.g. sudoCommand=sudo -i 

2.2.2.1.0   Mon Jul 11 10:31:14 PDT 2011
* client
1. fixed the source url option -s in srm-copy-status
2. added more network related exception handling

* setup
1. BESTMAN_SYSCONF file for both external variables and internal definitions
2. updates on bestman.server for external variables
3. updates on srm clients for external variables
4. updates on java process execution; added exex and $JAVA_SRM_OTHER_OPTS
5. updates on configure 
6. updates on SRM init scripts

2.2.2.0.13  Tue Jun 14 11:45:54 PDT 2011
* bestman
1. fixed file lifetime affecting file transfers in full mode
2. fixed eventLogLevel

* client
1. added exception handling on connection timeout for retry
2. added enhancements to retry SRM connections with time delay

2.2.2.0.12 Wed May  4 11:28:00 PDT 2011
* bestman
1. added minimal ping output handling. Additional outputs are available with authorization id.

* setup
1. Packaging includes LBNL.RFF (ReadFromFile) library in lib/plugin with README file. No set up is done by default.

* client
1. fixed unauthorized exception with correct exit code
2. fixed displaying space total size in srm-ping when null is returned from the SRM server

2.2.2.0.11   Fri Apr 22 21:25:29 PDT 2011
* bestman
1. added hanging FIFO pipe handling during the external total space size calculation call in some cases.
2. improved how external commands are called for space sizes.
   

2.2.2.0.10  Thu Apr 14 09:31:31 PDT 2011
* bestman
1. fixed non-requirement of MSSHost configuration entry in full mode
2. added the handle for file system delay for MSS staging request logging in some cases in full mode
3. added an improved embeded checksum calculation


2.2.2.0.9 Fri Apr  1 11:38:00 PDT 2011
* bestman
1. added handling of getUserName or getUID for the XACML based GUMS access
   change does not apply to SAML based GUMS access

2.2.2.0.8  Thu Mar 24 08:42:01 PDT 2011
* bestman
1. fixed cached total space size associalted with tokens in srmGetSpaceMetaData
   values come from the external command when defined.

2.2.2.0.7  Wed Mar 16 08:40:06 PDT 2011
* bestman
1. added totalBytesCommand for static token description.
   It works the same as "usedBytesCommand", and takes priority 
   over a given size. e.g.  If both size and totalBytesCommand are given,
   then totalBytesCommand will be used.

* setup
1. added information about totalBytesCommand in the bestman.rc

2.2.2.0.6 Wed Feb 23 09:46:33 PST 2011
* bestman
1. new copyright and license statements included
2. (full mode) fixed retrial mode in managed gsiftp transfers to remote srm

* srm clients 2
1. new copyright and license statements included
2. when gridftp transfer makes an error with "bad password" or "login incorrect", no more re-tries of the same connection.
3. fixed srm-ls for null space tokens
4. fixed 32bit space size request parameter

* srm tester
1. new copyright and license statements included

* setup
1. new copyright and license statements
2. source release on codeforge svn

2.2.2.0.5 Thu Dec 16 14:40:10 PST 2010
* bestman
1. (full mode) support for srm-copy from gsiftp to remote srm
2. Report DUPLICATION_ERROR in the gateway mode when client indicates.
  client indicates [reportduplicate:true] pair to the bestman2 gateway mode, 
  and server returns DUPLICATION_ERROR in srmPrepareToPut and srmCopy for its   
  underlying storage when the target exists.

* srm clients 2
1. fixed -statusmaxtime option
2. -connectiontimeout option applies only to gridftp idling transfers.
3. -connectiontimeout option exits gracefully with summary report and exit code.
4. -sethttptimeout option applies to SRM connections.
5. many single calls to srmPrepareToPut is bundled together as one single call
  with many files for some 3rd party copy cases such as gsiftp->srm and srm->srm.
6. -concurrency is updated to start as soon as TURL is retrieved and
  transfers are up to the concurrency setting.
7. -nooverwrite option is added to avoid duplicate trnasfers.
   Client sends reportduplicate:true indicator to bestman gateway servers.
8. -gatewayfriendly is added to skip srmPutDone and srmRelease calls for
   BeStMan Gateway mode (ONLY).

* setup
1. added --with-client-max-java-heap for max java heap size for clients.
   default is set to 512.  --with-max-java-heap works only for server now.
2. added --with-java-stack-size for java stack size for java threads.
   there is no default, and when set, 128 is recommended.


2.2.2.0.4 Mon Nov 22 10:37:31 PST 2010
* bestman
1. (full mode) fixed the return status for remote put case in consistent FILE_IN_CACHE

* srm clients
1. fixed exit codes for multiple files in input file
2. added -nowaitonremoteput on srm-copy for remote put case

2.2.2.0.3  Wed Nov  3 09:56:55 PDT 2010
* bestman
1. dependent libs are updated: privilege-xacml-2.2.5 and opensaml-2.3.1
2. added FQAN caching for GUMS-XACML connection

* srm clients
1. fixed wrong exit code when many requests collects statuses

* setup
1. client java api is separated from the dist pkg due to low usage

2.2.2.0.2  Tue Sep 14 15:35:36 PDT 2010
* bestman
1. (full mode) bug fix on monitoring long running requests
2. (full mode) bug fix on MSS queue monitoring

* srm clients
1. sync up to date

* srm tester
1. sync up to date

* setup
1. adjust default values for scalability options

2.2.2.0.1  Mon Jul 26 09:20:02 PDT 2010
* bestman
1. added a configure option for the max number of event log files
   configure --with-eventlog-num=<INT>   
2. added a configure option for the max size of a event log file in bytes
   configure --with-eventlog-size=<INT>  
3. added an option for connector queue size 
   configure --with-connector-queue-size=<INT>
4. added an option for connection acceptor thread size
   configure --with-connection-acceptor-thread-size<INT>
5. added MSS connection monitoring mechanism (Full mode only)

Note:
--with-connector-queue-size: size of connection accept queue. 
--with-connection-acceptor-thread-size: number of acceptor threads available 
                                 for the server's channel connector
--with-max-container-threads: size of thread pool available to the jetty server 

   
* srm clients
1. added support on the 3rd party trasnfers for multiple files in a request
2. added an option for http connection timeout in seconds 
   -sethttptimeout : default is 600 seconds
   e.g. srm-copy ...  -sethttptimeout 1800



2.2.2.0.0  Tue Jun  8 13:27:04 PDT 2010
* bestman
1. Retains all functionalities from the bestman 2.2.1.3.13
2. All dependent libraries are up to date.
3. Jetty based web service container
4. To control max container connection thread pool size,
   use --with-max-container-threads= option in the configure.
   Deftauls is 256.
5. bestman2 now only needs one https port open.
6. To control max java heap memory size,
   use --with-max-java-heap= option in the configure.
   Default is now 1024 (MBytes).
7. To debug requests on Jetty container,
   use --enable-debug-jetty option in the configure.
   Default is "disabled".
8. Supports both GUMS versions:
   e.g.
   ims contact: https://gumxserver.fnal.gov:8443/gums/services/GUMSAuthorizationServicePort
   xacml contact: https://gumxserver.fnal.gov:8443/gums/services/GUMSXACMLAuthorizationServicePort

* srm clients
1. Retains all functionalities from the bestman 2.2.1.3.13
2. All dependent libraries are up to date.

* srm tester
1. Retains all functionalities from the bestman 2.2.1.3.12
2. All dependent libraries are up to date.

* setup
1. Retains all functionalities from the bestman 2.2.1.3.13
2. configure is default to gateway mode
3. configure for full mode is with --enable-full-mode option.


